// Cube.cpp: implementation of the Cube class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SierpinskiSolids.h"
#include "Cube.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Cube::Cube()
{
	Pts[0].x = -1.0; Pts[0].y = -1.0; Pts[0].z = -1.0;
	Pts[1].x =  1.0; Pts[1].y = -1.0; Pts[1].z = -1.0;
	Pts[2].x =  1.0; Pts[2].y =  1.0; Pts[2].z = -1.0;
	Pts[3].x = -1.0; Pts[3].y =  1.0; Pts[3].z = -1.0;
	Pts[4].x = -1.0; Pts[4].y = -1.0; Pts[4].z =  1.0;
	Pts[5].x =  1.0; Pts[5].y = -1.0; Pts[5].z =  1.0;
	Pts[6].x =  1.0; Pts[6].y =  1.0; Pts[6].z =  1.0;
	Pts[7].x = -1.0; Pts[7].y =  1.0; Pts[7].z =  1.0;
}

Cube::~Cube()
{

}

void Cube::DrawFaces()
{
	static const int index[12][3] = { {0,1,2}, {0,2,3}, {1,5,2}, {2,5,6},
		{2,7,3}, {2,6,7}, {4,7,6}, {5,4,6}, {0,5,1}, {0,4,5}, {0,3,7}, {0,7,4} };
//	static const float colorIndex[12][3] = { {1,0,0}, {1,0,0}, {0,1,0}, {0,1,0},
//		{0,0,1}, {0,0,1}, {1,1,0}, {1,1,0}, {1,0,1}, {1,0,1}, {0,1,1}, {0,1,1} };
	static const float colorIndex[12][3] = { {1,0.8,0.8}, {1,0.8,0.8}, {0.8,1,0.8}, {0.8,1,0.8},
		{0.8,0.8,1}, {0.8,0.8,1}, {1,1,0.8}, {1,1,0.8}, {1,0.8,1}, {1,0.8,1}, {1,1,1}, {1,1,1} };
	float scale;

	 glBegin( GL_TRIANGLES );
		for( int i = 0; i < 12; i++ )
		{
			Vec3f crossVec;
			crossVec.crossProd( Pts[index[i][0]], Pts[index[i][1]], Pts[index[i][2]] );
			glNormal3f( crossVec.x, crossVec.y, crossVec.z );
			int ci = i;
			if( i % 2 == 0 )
				scale = 0.75 +	0.05*( (float) rand() / (float) RAND_MAX );
			glColor3f( scale * colorIndex[ci][0], scale * colorIndex[ci][1], scale * colorIndex[ci][2] );
			for( int j = 2; j >= 0; j-- )
			{
				glVertex3f( Pts[index[i][j]].x, Pts[index[i][j]].y, Pts[index[i][j]].z );
			}
		}
	 glEnd();

}

void Cube::CalcGrid()
{
	Vec3f pt1, pt2, pt3, pt4;
	float k_scale = 1.0;
	for( int k = 0; k < 4; k++ )
	{
		// Build base pts
		pt1 = k_scale*Pts[0] + (1.0-k_scale)*Pts[4];
		pt2 = k_scale*Pts[1] + (1.0-k_scale)*Pts[5];
		pt3 = k_scale*Pts[2] + (1.0-k_scale)*Pts[6];
		pt4 = k_scale*Pts[3] + (1.0-k_scale)*Pts[7];
		k_scale -= 0.3333333;
		float j_scale = 0.0;
		for( int j = 0; j < 4; j++ )
		{
			Vec3f tmpPt1, tmpPt2;
			tmpPt1 = j_scale*pt4 + (1.0-j_scale)*pt1;
			tmpPt2 = j_scale*pt3 + (1.0-j_scale)*pt2;
			j_scale+=0.3333333;
			float i_scale = 0.0;
			for( int i = 0; i < 4; i++ )
			{
				Grid[i][j][k] = i_scale*tmpPt2 + (1.0-i_scale)*tmpPt1;
				i_scale+=0.3333333;
			}
		}
	}
			
}
